using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace takmicenje_2020_kolo_1_zadatak_3
{
    class Program
    {
        static void Main(string[] args)
        {
            int T = int.Parse(Console.ReadLine());
            int[] nizZaRezultate = new int[T];
            for(int i=0;i<T;i++)
            {
                string[] s = Console.ReadLine().Split(' ');
                long n = long.Parse(s[0]);
                long m = long.Parse(s[1]);
                long[] nizOdobrenihGod = new long[n];
                long[] nizOdbijenihGod = new long[m];
                string[] c1 = Console.ReadLine().Split(' ');
                for(long q=0;q<n;q++)
                {
                    nizOdobrenihGod[q] = long.Parse(c1[q]); 
                }
                string[] c2 = Console.ReadLine().Split(' ');
                for (long q = 0; q < m; q++)
                {
                    nizOdbijenihGod[q] = long.Parse(c2[q]);
                }
                long[] nizZaRazlikeGodina = new long[n-1];
                Array.Sort(nizOdobrenihGod);
                for(int q=0;q<n-1;q++)
                {
                    nizZaRazlikeGodina[q] = nizOdobrenihGod[q + 1] - nizOdobrenihGod[q];
                }
                long x = nizZaRazlikeGodina.Min();
                for(int q=1;q<n;q++)
                {
                    if((nizOdobrenihGod[q] - nizOdobrenihGod[0]) %x != 0)
                    {
                        nizZaRezultate[i] = 0;
                    }
                    else
                    {
                        nizZaRezultate[i] = 1;
                    }
                }
                for (int q = 1; q < m; q++)
                {
                    if (Math.Abs(nizOdbijenihGod[q] - nizOdobrenihGod[0]) % x != 0)
                    {
                        nizZaRezultate[i] = 1;
                    }
                    else
                    {
                        nizZaRezultate[i] = 0;
                    }
                }
            }
            for (int i = 0; i < T; i++)
                Console.WriteLine(nizZaRezultate[i]);

        }
    }
}